Attribute VB_Name = "modTool"
Option Explicit

Private Type t_WinFind
  TitlePart     As String
  TitleFound    As String
  HwndFound     As Long
  Break         As Boolean
End Type

Private Declare Function EnumWindows Lib "USER32" ( _
    ByVal lpEnumFunc As Long, _
    ByVal lParam As Long _
  ) As Long

Private Declare Function GetWindowTextLength Lib "USER32" Alias "GetWindowTextLengthA" ( _
    ByVal hWnd As Long _
  ) As Long

Private Declare Function GetWindowText Lib "USER32" Alias "GetWindowTextA" ( _
    ByVal hWnd As Long, _
    ByVal lpString As String, _
    ByVal cch As Long _
  ) As Long


Private m_FSO         As FileSystemObject

Private m_sWinFind    As t_WinFind


Public Function FileExists( _
    ByVal vFile As String _
  ) As Boolean

  On Error GoTo err_handler
  
  If m_FSO Is Nothing Then
    Set m_FSO = New FileSystemObject
  End If
  
  FileExists = m_FSO.FileExists(vFile)
  
  GoTo endproc

err_handler:
  FileExists = False
endproc:

End Function

'--- Example to launch DbgView automatically
'
Public Sub CheckDebugView()

  '-- check if already running
  If FindWindowLike("DebugView") = 0 Then
      
    If FileExists(App.Path & "\dbgview.exe") Then
      Shell "dbgview.exe", vbNormalNoFocus
    End If
  
  End If

End Sub
    
Public Function FindWindowLike(ByVal vTitle As String) As Long
  
  With m_sWinFind
    .Break = False
    .TitlePart = vTitle
    .TitleFound = vbNullString
    .HwndFound = 0
  End With
  
  EnumWindows AddressOf EnumProc, 0
  
  If m_sWinFind.HwndFound <> 0 Then
    FindWindowLike = m_sWinFind.HwndFound
  End If
  
End Function


Private Function EnumProc( _
    ByVal hWnd As Long, _
    ByVal lParam As Long _
  ) As Long
  
  Dim WindowText As String
  Dim Retval As Long
  
  WindowText = Space(GetWindowTextLength(hWnd) + 1)
  Retval = GetWindowText(hWnd, WindowText, Len(WindowText))
  WindowText = Left$(WindowText, Retval)
  
  With m_sWinFind
    If InStr(WindowText, .TitlePart) Then
      .TitleFound = WindowText
      .HwndFound = hWnd
      .Break = True
    End If
  End With
  
  If Not m_sWinFind.Break Then
    EnumProc = 1
  End If

End Function

